//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  clrBlue
#property indicator_color2  clrLightSkyBlue
#property indicator_color3  clrRed
#property indicator_color4  clrPaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern double          Period1         =  12;
extern double          Period2         =  12;
extern double          Period3         =   5;
extern bool            alertsOn        = false;
extern bool            alertsOnCurrent = true;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";

//
//
//
//
//

double tvi[];
double tvihuu[];
double tvihud[];
double tvihdd[];
double tvihdu[];
double slope[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,tvihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tvihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tvihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tvihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,tvi);
   SetIndexBuffer(5,slope);

      //
      //
      //
      //
      //
         
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame==-99);
      TimeFrame         = MathMax(TimeFrame,_Period);

      //
      //
      //
      //   
      //
      
      IndicatorShortName(timeFrameToString(TimeFrame)+" Blau ergodic tick volume ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tvihuu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
     for (int i=limit; i>=0; i--)
     {
         double upTicks = (Volume[i]+(Close[i]-Open[i])/Point) / 2.0;
         double dnTicks = (Volume[i] - upTicks);
         double avgUp = iEma(iEma(upTicks,Period1,i,0),Period2,i,1);
         double avgDn = iEma(iEma(dnTicks,Period1,i,2),Period2,i,3);
            if (avgUp+avgDn != 0)
                  tvi[i] = iEma(100.0*(avgUp-avgDn)/(avgUp+avgDn),Period3,i,4);
            else  tvi[i] = iEma(0                                ,Period3,i,4);                
            tvihuu[i] = EMPTY_VALUE;
            tvihud[i] = EMPTY_VALUE;
            tvihdd[i] = EMPTY_VALUE;
            tvihdu[i] = EMPTY_VALUE;

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (tvi[i] > tvi[i+1]) slope[i] =  1;
               if (tvi[i] < tvi[i+1]) slope[i] = -1;
               if (tvi[i]>0)
               if (slope[i]==1)
                     tvihuu[i] = 1;
               else  tvihud[i] = 1;
               if (tvi[i]<0)
               if (slope[i]==-1)
                     tvihdd[i] = 1;
               else  tvihdu[i] = 1;
      }
      
      //
      //
      //
      //
      //
    
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; 
      
      //
      //
      //
      //
      //
      
      if (tvihuu[whichBar+1] == EMPTY_VALUE && tvihuu[whichBar] != EMPTY_VALUE) doAlert(whichBar,"strong buy");
      if (tvihud[whichBar+1] == EMPTY_VALUE && tvihud[whichBar] != EMPTY_VALUE) doAlert(whichBar,"weak buy");
      if (tvihdd[whichBar+1] == EMPTY_VALUE && tvihdd[whichBar] != EMPTY_VALUE) doAlert(whichBar,"strong sell");
      if (tvihdu[whichBar+1] == EMPTY_VALUE && tvihdu[whichBar] != EMPTY_VALUE) doAlert(whichBar,"weak sell");
    }         
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-98,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         tvihuu[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Period1,Period2,Period3,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);     
         tvihud[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Period1,Period2,Period3,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);     
         tvihdd[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Period1,Period2,Period3,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);     
         tvihdu[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Period1,Period2,Period3,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);     
   }
return(0);
         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
} 

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Blau - ergodic tvi ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Blau - ergodic tvi "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


